
% main routine : calls MgnCalibration
%                        and an auxilliary function 
%                        which performs 3D rotations
%
%
%   Original code by Alain Barraud  2008
%   Modified for real data by Mitch 2010
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all;%close previously open figures
clear
load magdata.txt

data=magdata';

n=length(data(1,:))

% plot raw data
figure;plot3(data(1,:),data(2,:),data(3,:),'*');
grid on
axis square

[A,c] = MgnCalibration(data); %call routine

%A
%c

%plot corrected data
Caldata=A*(data-repmat(c,1,n));% calibrated data
figure;plot3(Caldata(1,:),Caldata(2,:),Caldata(3,:),'*'); grid on;axis square
set(gca,'xlim',[-1 1],'ylim',[-1 1],'zlim',[-1 1])
disp('estimated shape')
disp([num2str(A,'%15.3e'),['   ';'   ';'   ']])
disp('estimated center')
disp([num2str(c,'%15.3e'),['   ';'   ';'   ']])


%sample point w = A*(v-c)

v(1)=131.000;
v(2)=167.000;
v(3)=-377.000;
v
c
temp=v'-c
w=A*temp
